package com.nisum.junit.helper;

import org.junit.Before;
import org.junit.Test;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.fail;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class StringHelperTest {

   // StringHelper helper = new StringHelper();

    StringHelper helper;

    @Before
    public void before(){
        System.out.println("Before test");
    }

    @Test
    public void testTruncateAInFirst2Positions_AInFirst2Positions(){
        // Creating instance of StringHelper class.
        //TODO: AACD => CD , ACD => CD , CDEF => CDEF , CDAA => CDAA. Bacause, only first 2 A's it will truncate.
        assertEquals("CD", helper.truncateAInFirst2Positions("AACD"));
        assertEquals("CD", helper.truncateAInFirst2Positions("ACD"));
        assertEquals("CDEF", helper.truncateAInFirst2Positions("CDEF"));
        assertEquals("CDAA", helper.truncateAInFirst2Positions("CDAA"));
        assertEquals("EEAD", helper.truncateAInFirst2Positions("EEAD"));
        assertEquals("CCCA", helper.truncateAInFirst2Positions("CCCA"));
    }

    @Test
    public void testTruncateAInFirst2Positions2_AInFirst1Position(){
        assertEquals("CD", helper.truncateAInFirst2Positions("ACD"));
    }

    @Test
    public void testTruncateAInFirst2Positions_WithoutAInAllPositions(){
        assertEquals("CDEF", helper.truncateAInFirst2Positions("CDEF"));
    }

    @Test
    public void testTruncateAInFirst2Positions_AInLast2Positions(){
        assertEquals("CDAA", helper.truncateAInFirst2Positions("CDAA"));
    }

    @Test
    public void testAreFirstAndLastTwoCharactersTheSame_BasicNegativeScenario(){

        // Use inline option to make the code less.
        /*boolean actual = helper.areFirstAndLastTwoCharactersTheSame("ABCD");
        boolean expected = false;*/
        assertEquals(false, helper.areFirstAndLastTwoCharactersTheSame("ABCD"));

        // Using assertFalse method which checks the provided value (actual value) is false or not.
        assertFalse(helper.areFirstAndLastTwoCharactersTheSame("ABCD"));
    }

    // Using assertTrue
    @Test
    public void testAreFirstAndLastTwoCharactersTheSame_BasicPositiveScenario(){

        assertTrue( helper.areFirstAndLastTwoCharactersTheSame("ABAB"));
    }
}
